<script setup lang="ts">
const { fetchForInternalReview, fetchForOfficialSubmission, update } =
  useGOAnnotationService();
const { addMessage } = useSnackBarStore();
const { data, pending, error } = useAsyncData("go-annotation-review", () =>
  fetchForInternalReview(),
);
const headers = [
  {
    title: "Pending GO annotations",
    key: "item",
    value: (item: any) => item,
    sortable: false,
  },
];
const selectedItems = ref([] as string[]);
const count = computed(() => selectedItems.value.length);

const acceptLoading = ref(false);
const accept = async () => {
  if (count.value === 0) return;
  acceptLoading.value = true;
  try {
    const items = selectedItems.value.map(
      (id) => ({ id, status: "INTERNAL" }) as const,
    );
    await update(items);
    addMessage({
      text: `${count.value} GO annotations accepted`,
      color: "success",
    });
    data.value =
      data.value?.filter((item) => !selectedItems.value.includes(item.id)) ||
      [];
    selectedItems.value = [];
  } catch {
    addMessage({ text: "Failed to accept GO annotations", color: "error" });
  } finally {
    acceptLoading.value = false;
  }
};

const deleteLoading = ref(false);
const delete_ = async () => {
  if (count.value === 0) return;
  deleteLoading.value = true;
  try {
    const items = selectedItems.value.map(
      (id) => ({ id, status: "TO_BE_DELETED" }) as const,
    );
    await update(items);
    addMessage({
      text: `${count.value} GO annotations deleted`,
      color: "success",
    });
    data.value =
      data.value?.filter((item) => !selectedItems.value.includes(item.id)) ||
      [];
    selectedItems.value = [];
  } catch {
    addMessage({ text: "Failed to delete GO annotations", color: "error" });
  } finally {
    deleteLoading.value = false;
  }
};
</script>

<template>
  <AsyncView
    :error="error"
    :loading="pending"
    error-message="Failed to fetch GO annotations for internal review"
  >
    <v-data-table
      v-model="selectedItems"
      :items="data || []"
      :headers="headers"
      item-value="id"
      show-select
    >
      <template #item.item="{ item }">
        <GOAnnotationItem :annotation="item" class="my-4" />
      </template>
    </v-data-table>
    <div class="mt-4">
      <v-btn
        color="success"
        variant="text"
        :loading="acceptLoading"
        @click="accept"
      >
        Accept all selected ({{ count }})
      </v-btn>
      <v-btn
        color="error"
        variant="text"
        :loading="deleteLoading"
        @click="delete_"
      >
        Delete all selected ({{ count }})</v-btn
      >
    </div>
  </AsyncView>
  <div class="mt-8">
    <TextDownloader
      :text="fetchForOfficialSubmission"
      filename="go_ibb.xlsx"
      filetype="xlsx"
      btn-variant="elevated"
    >
      Download reviewed GO terms
    </TextDownloader>
  </div>
</template>
